<template>
  <div :class="classWrap">
    <slot />
    <span v-show="on" class="Pending__Overlay">
      <div class="lds-ring" :style="getRingStyle">
        <div />
        <div />
        <div />
        <div />
      </div>
      <span class="Pending__Overlay__Bg" :style="backgroundStyle" />
    </span>
  </div>
</template>

<script>
export default {
  props: {
    backgroundColor: {
      default: "#F5F6F8",
      type: String
    },
    classes: {
      default: "",
      type: String
    },
    color: {
      default: "#12d116",
      type: String
    },
    iconScale: {
      default: 1,
      type: Number
    },
    on: {
      default: false,
      type: Boolean
    }
  },

  computed: {
    getRingStyle() {
      return `transform: scale(${this.iconScale})`;
    },
    backgroundStyle() {
      return {
        backgroundColor: this.backgroundColor
      };
    },
    classWrap() {
      return {
        Pending: true,
        [this.classes]: this.classes.length > 0
      };
    },
    iconStyle() {
      return {
        color: this.color,
        fontSize: this.iconSize
      };
    }
  }
};
</script>

<style lang="scss" scoped>
.Pending {
  position: relative;

  &__Overlay {
    align-items: center;
    bottom: 0;
    display: flex;
    justify-content: center;
    left: 0;
    position: absolute;
    top: 0;
    width: 100%;
    z-index: 999;

    .lds-ring {
      display: inline-block;
      position: relative;

      z-index: 999;
    }
    .lds-ring div {
      box-sizing: border-box;
      display: block;
      position: absolute;
      border-radius: 50%;
      width: 44px;
      height: 44px;
      left: calc(50% - 22px);
      top: calc(50% - 22px);
      border: 4px solid rgba(var(--vs-primary), 1);
      animation: lds-ring 1s cubic-bezier(0.5, 0, 0.5, 1) infinite;
      border-color: rgba(var(--vs-primary), 1) transparent transparent
        transparent;
    }
    .lds-ring div:nth-child(1) {
      animation-delay: -0.05s;
    }
    .lds-ring div:nth-child(2) {
      animation-delay: -0.1s;
    }
    .lds-ring div:nth-child(3) {
      animation-delay: -0.15s;
    }
    @keyframes lds-ring {
      0% {
        transform: rotate(0deg);
      }
      100% {
        transform: rotate(360deg);
      }
    }

    &__Bg {
      bottom: 0;
      content: "";
      left: 0;
      opacity: 0.7;
      position: absolute;
      top: 0;
      width: 100%;
    }

    &__Icon {
      position: relative;
      z-index: 999;
    }
  }
}
</style>
